/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.payroll.payment.action;

import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.legal.LegalConst;
import jp.mosp.payroll.base.PayrollAction;
import jp.mosp.payroll.dao.CmCompanyDao;
import jp.mosp.payroll.dto.CmCompanyDto;
import jp.mosp.payroll.payment.vo.CompanyCardVo;

public class CompanyCardAction extends PayrollAction {

	// コマンド
	private static final String CMD_COMPANY_CARD_SHOW   = "U5248";
	private static final String CMD_COMPANY_CARD_INSERT = "U5249";
	private static final String CMD_COMPANY_CARD_UPDATE = "U5250";

	/**
	 * Actionの初期化を行う。<br><br>
	 * 以下の処理を行う。
	 * <ul><li>
	 * {@link PayrollAction#PayrollAction()}
	 * </li></ul>
	 */
	public CompanyCardAction() {
		super();
	}

	/* (non-Javadoc)
	 * @see jp.mosp.common.common.BaseAction#getSpecificVo()
	 */
	@Override
	protected BaseVo getSpecificVo() {
		return new CompanyCardVo();
	}
	
	/**
	 * アクション
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// PAYROLL権限確認
		confirmPayrollAuth();
		// VO取得及び設定
		prepareVo();
		CompanyCardVo vo = (CompanyCardVo)getVo();
		// パラメータ取得
		vo.setParams(request);
		// 厚生年金基金加入有無プルダウン作成
		vo.aryPltFundParticipation = LegalConst.FUND_PARTICIPATION_ARRAY;
		// DTOの取得
		CmCompanyDto dto;
		Object obj = session.getAttribute(MospConst.ATT_DTO);
		dto = obj instanceof CmCompanyDto ? (CmCompanyDto)obj : null;
		// コマンド毎の処理
		if (cmd.equals(CMD_COMPANY_CARD_SHOW)) {
			vo.setTxtComHealthPremiumRate  ("0.0");
			vo.setTxtComNursingPremiumRate ("0.0");
			vo.setTxtComPensionPremiumRate ("0.0");
			vo.setTxtComFundPremiumRate    ("0.0");
			vo.setTxtComUnemployPremiumRate("0.0");
			vo.setTxtHealthPremiumRate  ("0.0");
			vo.setTxtNursingPremiumRate ("0.0");
			vo.setTxtPensionPremiumRate ("0.0");
			vo.setTxtFundPremiumRate    ("0.0");
			vo.setTxtUnemployPremiumRate("0.0");

			// 会社情報検索
			dto = select(vo);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_COMPANY_CARD_INSERT)) {
			// 新規登録
			dto = insert(vo);
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_COMPANY_CARD_UPDATE)) {
			// 更新
			dto = update(vo, dto);
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	/**
	 * データ検索
	 * @param vo 対象VO
	 * @return 検索結果DTO
	 * @throws Exception
	 */
	public CmCompanyDto select(CompanyCardVo vo) throws Exception {
		// DAO準備
		CmCompanyDao dao = new CmCompanyDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// DTO準備
		CmCompanyDto dto;
		dto = dao.findAll();
		if (dto == null) {
			// モード設定
			vo.setMode(CompanyCardVo.MODE_INSERT);	
		} else {
			// データの設定
			vo.setFields(dto);
			// モード設定
			vo.setMode(CompanyCardVo.MODE_UPDATE);	
		}
		return dto;
	}
	/**
	 * データ挿入
	 * @param vo 対象VO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	public CmCompanyDto insert(CompanyCardVo vo) throws Exception {
		// コネクションの取得及びDAOの準備
		getConnection();
		// DAO準備
		CmCompanyDao dao = new CmCompanyDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// DTO準備
		CmCompanyDto dto = new CmCompanyDto();
		vo.setDtoFields(dto);
		// パラメータの妥当性確認
		if (vo.validate()) {
			// 存在チェック
			chkDuplicate(dao.findForKey(vo.getTxtCompanyCode()), vo);
			vo.setDtoFields(dto);
			// データの挿入
			dao.insert(dto);
			// DTOの再取得
			dto = dao.findForKey(dto.getCompanyCode());
			// コミット
			commit();
			// モード設定
			vo.setMode(CompanyCardVo.MODE_UPDATE);
			// メッセージ設定
			vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_INSERT, ""));
		}
		return dto;
	}
	/**
	 * データ更新
	 * @param vo 対象VO
	 * @param dto 対象DTO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	public CmCompanyDto update(CompanyCardVo vo, CmCompanyDto dto) throws Exception {
		// コネクションの取得及びDAOの準備
		getConnection();
		// DAO準備
		CmCompanyDao dao = new CmCompanyDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// DTO準備
		CmCompanyDto retDto = new CmCompanyDto();
		// パラメータの妥当性確認
		if (vo.validate()) {
			// 排他確認
			chkExclusive(dto, dao.findForUpdate(vo.getTxtCompanyCode()), vo);
			// DTOの準備
			vo.setDtoFields(dto);
			// データの更新
			dao.update(dto);
			// DTOの再取得
			retDto = dao.findForKey(dto.getCompanyCode());
			// コミット
			commit();
			// モード設定
			vo.setMode(CompanyCardVo.MODE_UPDATE);
			// メッセージ設定
			vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
			
		}
		return retDto;
	}
	
}
